/*
 * Copyright (c) 2005 DocJava, Inc. All Rights Reserved.
 */
package addbk.print.labels;

import utils.CompactJava;

import java.io.*;
import java.util.prefs.Preferences;

public class LabelBean implements Serializable {
    private String name = "avery 5160";
    private int numberOfLabelsPerColumn = 10;
    private int numberOfLabelsPerSheet = 30;
    private int verticalGutterInMM = 1;
    private int horizontalGutterInMM = 4;

    private int labelWidthInMM = 66;
    private int labelHeightInMM = 25;

    private int pageMarginRightInMM = 5;
    private int pageMarginLeftInMM = 5;

    private int pageMarginTopInMM = 12;
    private int pageMarginBottomInMM = 12;


    private static String key = "labelBean";

    public LabelBean() {

    }

    /**
     * saves the properties to the Preferences of the userRoot
     */
    public void save() {
        try {
            Preferences p = Preferences.userRoot();
            ByteArrayOutputStream baos = new
                    ByteArrayOutputStream();
            ObjectOutputStream oos = new
                    ObjectOutputStream(baos);
            oos.writeObject(this);
            baos.close();
            p.putByteArray(key, baos.toByteArray());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        LabelBean lb = new LabelBean();
        lb.setName("avery 5371");
        lb.setPageMarginLeftInMM(19);
        lb.setPageMarginRightInMM(19);
        lb.setPageMarginTopInMM(13);
        lb.setPageMarginTopInMM(13);
        lb.setNumberOfLabelsPerSheet(10);
        lb.setNumberOfLabelsPerColumn(5);
        lb.setVerticalGutterInMM(0);
        lb.setHorizontalGutterInMM(0);
        System.out.println(lb);
    }

    public String toString() {
        return CompactJava.toXml(this);
    }

    /**
     * restores the properties from the preference in the user root.
     */
    public static LabelBean restore() {
        try {
            Preferences p = Preferences.userRoot();
            byte b [] = p.getByteArray(key, null);
            if (b == null)
                return new LabelBean();
            ByteArrayInputStream bais = new
                    ByteArrayInputStream(b);
            ObjectInputStream ois = new
                    ObjectInputStream(bais);
            Object o = ois.readObject();
            bais.close();
            return (LabelBean) o;
        } catch (IOException e) {
            //e.printStackTrace();
        } catch (ClassNotFoundException e) {
            // e.printStackTrace();
        }
        return new LabelBean();
    }

    public int getPageMarginRightInMM() {
        return pageMarginRightInMM;
    }

    public void setPageMarginRightInMM(int pageMarginRightInMM) {
        this.pageMarginRightInMM = pageMarginRightInMM;
    }

    public int getPageMarginLeftInMM() {
        return pageMarginLeftInMM;
    }

    public void setPageMarginLeftInMM(int pageMarginLeftInMM) {
        this.pageMarginLeftInMM = pageMarginLeftInMM;
    }

    public int getPageMarginTopInMM() {
        return pageMarginTopInMM;
    }

    public void setPageMarginTopInMM(int pageMarginTopInMM) {
        this.pageMarginTopInMM = pageMarginTopInMM;
    }

    public int getPageMarginBottomInMM() {
        return pageMarginBottomInMM;
    }

    public void setPageMarginBottomInMM(int pageMarginBottomInMM) {
        this.pageMarginBottomInMM = pageMarginBottomInMM;
    }

    public int getNumberOfLabelsPerSheet() {
        return numberOfLabelsPerSheet;
    }

    public void setNumberOfLabelsPerSheet(int numberOfLabelsPerSheet) {
        this.numberOfLabelsPerSheet = numberOfLabelsPerSheet;
    }

    public int getNumberOfLabelsPerColumn() {
        return numberOfLabelsPerColumn;
    }

    public void setNumberOfLabelsPerColumn(int numberOfLabelsPerColumn) {
        this.numberOfLabelsPerColumn = numberOfLabelsPerColumn;
    }

    public int getHorizontalGutterInMM() {
        return horizontalGutterInMM;
    }

    public void setHorizontalGutterInMM(int horizontalGutterInMM) {
        this.horizontalGutterInMM = horizontalGutterInMM;
    }

    public int getVerticalGutterInMM() {
        return verticalGutterInMM;
    }

    public void setVerticalGutterInMM(int verticalGutterInMM) {
        this.verticalGutterInMM = verticalGutterInMM;
    }

    public int getLabelWidthInMM() {
        return labelWidthInMM;
    }

    public void setLabelWidthInMM(int labelWidthInMM) {
        this.labelWidthInMM = labelWidthInMM;
    }

    public int getLabelHeightInMM() {
        return labelHeightInMM;
    }

    public void setLabelHeightInMM(int labelHeightInMM) {
        this.labelHeightInMM = labelHeightInMM;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }
}
